/*
 Rexx -  Kalender gadget zeigt den aktuellen Monat
*/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/* berprfen, ob das Script direkt begonnen wurde */
IF ARG() = 0 THEN DO
    /* Starten des gadget */
    PARSE SOURCE . . theScript
    IF ARG(1)="" THEN
        CALL SysSetObjectdata "<WP_DESKTOP>", "WIZLAUNCHGADGET="theScript
        Exit(0)
END

NUMERIC DIGITS 15 /* Wir bentigen dieses fr die Berechnung mit Hex Zahlen */

SELECT
    WHEN ARG(1)="/GADGETSTARTED" THEN DO
        theObject=ARG(2)
        SIGNAL ON SYNTAX NAME errorHandler
        SIGNAL ON ERROR NAME errorHandler
        SIGNAL ON FAILURE NAME errorHandler

		INIFile=system.path.wpswizardini

	    PARSE SOURCE . . theScript
		scriptPath=FILESPEC("d", theScript)||FILESPEC("p", theScript)

        /* Info fr die Speicherung von Daten in WPS-wizard ini file */
        APPKEY="gcalendargadget"
		GROUPPOS="grouppos"
		GROUPBACKCOLOR="groupbackcolor"
		GROUPBORDER="groupborder"
		GROUPBORDERWIDTH="groupborderwidth"

        MONTHFONT="monthfont"
        MONTHCOLOR="monthcolor"

		MHEADFONT="mheadfont"
		MHEADCOLOR="mheadcolor"
		MHEADSCOLOR="mheadscolor"

		DAYFONT="dayfont"
		DAYCOLOR="daycolor"

		YEARFONT="yearfont"
		YEARCOLOR="yearcolor"
		YEARSCOLOR="yearscolor"

		/* Init Standardwerte  */
		childsLocked="YES"
		drawBorder=0
		NORMAL_BORDER=1
		SUNKEN_BORDER=2
		COLOR_BORDER=3

		/*** Lassen Sie uns mit dem container beginnen ***/
		/* Standard Position nach der Installation */
		defaultPos=system.screen.width-300||" 250 256 200"
		PARSE VAR defaultPos x y cx cy rest

		/* Standard Farbe */
		backColor=X2D('8080ff')
		foreColor=X2D('dddddd')

		/* gespeichertes Randinfo erhalten, wenn vorhanden */
		ret=Sysini(INIFile, APPKEY, GROUPBORDER)
		IF ret >< "ERROR:" THEN drawBorder=STRIP(ret)

		/* erstellen eines Bild container gadget */
		stem._x=x		/* x  */
		stem._y=y		/* y  */
		stem._cx=cx		/* cx */
		stem._cy=cy		/* cy */

		stem._type=IMAGE_GADGET		/* Gadget type */
		stem._hwnd=ARG(3)			/* hwnd */
		stem._flags=GSTYLE_POPUP + GSTYLE_NORESIZE	/* Wir mchten ein popup menu und keine Grennderung */
		SELECT
			WHEN drawBorder=COLOR_BORDER THEN
				stem._flags=stem._flags + GSTYLE_COLORBORDER
			WHEN drawBorder=NORMAL_BORDER THEN
				stem._flags=stem._flags + GSTYLE_BORDER
			WHEN drawBorder=SUNKEN_BORDER THEN
				stem._flags=stem._flags + GSTYLE_SUNKENBORDER
			OTHERWISE
				NOP
		END
		stem._font="10.Helv" /* font */

		/* Erhalten der (Gruppen) Speicherung Position wenn vorhanden */
		ret=Sysini(INIFile, APPKEY, GROUPPOS)
		IF  ret >< "ERROR:" THEN DO
			PARSE VAR ret stem._x stem._y stem._cx stem._cy rest
			x = stem._x
			y = stem._y
			cx = stem._cx
			cy = stem._cy
		END

		/* erstellen des gadget auf dem Desktop */
		ret=WizCreateGadget("DESKTOP", "stem.", "groupGadget")
		call groupGadget.Image scriptPath||"gcalendar.gif"

		/* Erhalten der Hintergrund Farbe. Dieses ist die Farbe des Randes */
		ret=Sysini(INIFile, APPKEY, GROUPBACKCOLOR)
		IF  ret >< "ERROR:" THEN
			call groupGadget.backcolor ret
		ELSE
			call groupGadget.backcolor backcolor

		/*** Jetzt fahren wir mit dem ersten Kind fort: dem Kalender ***/
        /* Gadget erzeugt Info */
        thestem._x=x+35                 /* x  */
        thestem._y=y                    /* y  */
        thestem._cx=cx-35               /* cx */
        thestem._cy=cy-53               /* cy */
        thestem._type=HTML_GADGET       /* Gadget type */
        thestem._hwnd=ARG(3)            /* hwnd */
        thestem._flags=0				/* Nichts */
        thestem._font="5.System VIO"	/* font - muss monospaced sein */

        col1 = '<font color="#69708a">' /* Tage (berschrift) */
        col2 = '<font color="#ff308a">' /* Sonntag (rtlich) */
		col3 = '<font color="#6970ff">' /* Heute (blulich) */
	    col8 = '<font color="#00bb00">' /* Woche (grnlich) */
        mon_str = 'Januar Februar Mrz April Mai Juni Juli August September Oktober November Dezember'

        /* Erhalten der gespeicherten Schrift wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, MONTHFONT)
        IF  ret <> "ERROR:" THEN DO
            thestem._font=ret
        END

        /* erstelle gadget */
        rc=WizCreateGadget("groupGadget", "thestem." , "monthGadget")

        /* Erhalten der gespeicherten Farbe wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, MONTHCOLOR)
        IF  ret <> "ERROR:" THEN DO
            call groupGadget.monthGadget.Color ret
        END

		/*** zweites Kind: der Monats Name ***/
        /* Gadget create info */
        thestem._x=x+63                 /* x  */
        thestem._y=y+130                /* y  */
        thestem._cx=150                 /* cx */
        thestem._cy=50                  /* cy */
        thestem._type=HTML_GADGET       /* Gadget type */
        thestem._hwnd=ARG(3)            /* hwnd */
        thestem._flags=0				/* Nichts */
        thestem._font="10.Arial Black"	/* font */

        col4 = '<font color="#868d9f">' /* grosser Monat */

        /* Erhalten der gespeicherten Schrift wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, MHEADFONT)
        IF  ret <> "ERROR:" THEN DO
            thestem._font=ret
        END

        /* erstelle gadget */
        rc=WizCreateGadget("groupGadget", "thestem." , "monthHeadGadget")

        /* Erhalten der gespeicherten Farbe wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, MHEADCOLOR)
        IF  ret <> "ERROR:" THEN DO
            call groupGadget.monthHeadGadget.Color ret
        END

		/*** drittes Kind: der Monats Name Schatten ***/
        /* Gadget create info */
        thestem._x=x+70                 /* x  */
        thestem._y=y+125                /* y  */
        thestem._cx=150                 /* cx */
        thestem._cy=50                  /* cy */
        thestem._type=HTML_GADGET       /* Gadget type */
        thestem._hwnd=ARG(3)            /* hwnd */
        thestem._flags=0				/* Nichts */
        thestem._font="10.Arial Black"	/* font */

        col5 = '<font color="#b6c1d5">' /* grosser monats Schatten */

        /* Erhalten der gespeicherten Schrift wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, MHEADFONT)
        IF  ret <> "ERROR:" THEN DO
            thestem._font=ret
        END

        /* erstelle gadget */
        rc=WizCreateGadget("groupGadget", "thestem." , "monthShadeGadget")

        /* Erhalten der gespeicherten Farbe wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, MHEADSCOLOR)
        IF  ret <> "ERROR:" THEN DO
            call groupGadget.monthShadeGadget.Color ret
        END

		/*** viertes Kind: die Tag Nummer ***/
        /* Gadget create info */
        thestem._x=x+20                 /* x  */
        thestem._y=y+156                /* y  */
        thestem._cx=50                  /* cx */
        thestem._cy=30                  /* cy */
        thestem._type=HTML_GADGET       /* Gadget type */
        thestem._hwnd=ARG(3)            /* hwnd */
        thestem._flags=0				/* Nichts */
        thestem._font="10.Arial Bold"	/* font */

        /* Erhalten der gespeicherten Schrift wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, DAYFONT)
        IF  ret <> "ERROR:" THEN DO
            thestem._font=ret
        END

        /* erstelle gadget */
  		rc=WizCreateGadget("groupGadget", "thestem." , "dayNumGadget")

        /* Erhalten der gespeicherten Farbe wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, DAYCOLOR)
        IF  ret <> "ERROR:" THEN DO
            call groupGadget.dayNumGadget.Color ret
        END

		/*** fnftes Kind ***/
        /* Gadget create info */
        thestem._x=x+182                /* x  */
        thestem._y=y+148                /* y  */
        thestem._cx=100                 /* cx */
        thestem._cy=30                  /* cy */
        thestem._type=HTML_GADGET       /* Gadget type */
        thestem._hwnd=ARG(3)            /* hwnd */
        thestem._flags=0				/* Nichts */
        thestem._font="10.Courier Bold"	/* font - muss monospaced sein */

        /* Erhalten der gespeicherten Schrift wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, YEARFONT)
        IF  ret <> "ERROR:" THEN DO
            thestem._font=ret
        END

        col6 = '<font color="#ffffff">' /* Jahr */

        /* erstelle gadget */
        rc=WizCreateGadget("groupGadget", "thestem." , "yearNumGadget")

        /* Erhalten der gespeicherten Farbe wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, YEARCOLOR)
        IF  ret <> "ERROR:" THEN DO
            call groupGadget.yearNumGadget.Color ret
        END

		/*** sechstes Kind ***/
        /* Gadget erstellt info */
        thestem._x=x+184                /* x  */
        thestem._y=y+146                /* y  */
        thestem._cx=100                 /* cx */
        thestem._cy=30                  /* cy */
        thestem._type=HTML_GADGET       /* Gadget type */
        thestem._hwnd=ARG(3)            /* hwnd */
        thestem._flags=0				/* Nichts */
        thestem._font="10.Courier Bold"	/* font - muss monospaced sein */

        col7 = '<font color="#b6c1e5">' /* Jahes Schatten */

        /* Erhalten der gespeicherten Schrift wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, YEARFONT)
        IF  ret <> "ERROR:" THEN DO
            thestem._font=ret
        END

        /* erstelle gadget */
        rc=WizCreateGadget("groupGadget", "thestem." , "yearShadeGadget")

        /* Erhalten der gespeicherten Farbe wenn vorhanden */
        ret=Sysini(INIFile, APPKEY, YEARSCOLOR)
        IF  ret <> "ERROR:" THEN DO
            call groupGadget.yearShadeGadget.Color ret
        END

		/*** wir fahren fort das ganze gadget zu initialisieren ***/
        /* einstellen gadget text - erstelle Kalendar fr aktuellen Monat */
		CALL monthCurrent

		/* sperre alle Kinder */
		call groupGadget.monthGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
		call groupGadget.monthShadeGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
		call groupGadget.monthHeadGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
		call groupGadget.dayNumGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
		call groupGadget.yearNumGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
		call groupGadget.yearShadeGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE

        /* Starten eines timer bergeben einer Nachricht alle 1000ms  */
        ret=WPSWizCallWinFunc("winStartTimer", ARG(3), 10, 1000)

        /* Gadget message loop */
        DO FOREVER
            ret=WizGetMessage(ARG(3))
            IF ret<>'' THEN
                INTERPRET "call "ret
        END

        EXIT(0)
    END
    OTHERWISE
        /* Wir sollten hier fertig sein... */
        Exit(0)
END
exit(0)

groupGadget.onPopUp:
/*
	ARG(1): hwnd of client area
	ARG(2): x
	ARG(3): y
*/
	menu.0=12
	IF childsLocked="YES" THEN
		menu.1="~entsperre Kinder"
	ELSE
		menu.1="~sperre Kinder"

	menu.2="-" /* Separator */
	menu.3="~kein Rand"
	menu.4="~Rand"
	menu.5="~eingesunkener Rand"
	menu.6="~farbiger Rand"
    menu.7="-"
    menu.8="vorheriger Monat"
    menu.9="aktueller Monat"
    menu.10="nchster Monat"
	menu.11="-"
	menu.12="~Beende Gadget"

	menu._x=ARG(2)
	menu._y=ARG(3)

	ret=WPSWizCallWinFunc("menuPopupMenu", ARG(1), 'menu.')

	SELECT
		WHEN drawBorder=NORMAL_BORDER THEN
			ret=WPSWizCallWinFunc("menuCheckItem", ret, 4, 0, 1)
		WHEN drawBorder=SUNKEN_BORDER THEN
			ret=WPSWizCallWinFunc("menuCheckItem", ret, 5, 0, 1)
		WHEN drawBorder=COLOR_BORDER THEN
			ret=WPSWizCallWinFunc("menuCheckItem", ret, 6, 0, 1)
		OTHERWISE
			ret=WPSWizCallWinFunc("menuCheckItem", ret, 3, 0, 1)
	END

return

groupGadget.onCommand:
/*
	ARG(1): hwnd of client area
	ARG(2): ID
	ARG(3): source (menu or button)
*/
	PARSE SOURCE . . theScript

	SELECT
	WHEN ARG(2)=1 THEN DO
		IF childsLocked="YES" THEN DO
			/* Kinder sind nun entsperrt */
			childsLocked="NO"
			call groupgadget.monthGadget.style 0, GSTYLE_NOACTIVATE
			call groupgadget.monthHeadGadget.style 0, GSTYLE_NOACTIVATE
			call groupgadget.monthShadeGadget.style 0, GSTYLE_NOACTIVATE
			call groupGadget.dayNumGadget.style 0, GSTYLE_NOACTIVATE
			call groupGadget.yearNumGadget.style 0, GSTYLE_NOACTIVATE
			call groupGadget.yearShadeGadget.style 0, GSTYLE_NOACTIVATE
		END
		ELSE DO
			childsLocked="YES"
			call groupgadget.monthGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
			call groupgadget.monthHeadGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
			call groupgadget.monthShadeGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
			call groupGadget.dayNumGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
			call groupGadget.yearNumGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
			call groupGadget.yearShadeGadget.style GSTYLE_NOACTIVATE, GSTYLE_NOACTIVATE
		END
	END
	WHEN ARG(2)=3 THEN DO
		drawBorder=0
		call groupgadget.style 0, GSTYLE_SUNKENBORDER + GSTYLE_BORDER + GSTYLE_COLORBORDER
	END
	WHEN ARG(2)=4 THEN DO
		/* User mchte einen Rand */
		drawBorder=1
		call groupgadget.style GSTYLE_BORDER, GSTYLE_SUNKENBORDER + GSTYLE_BORDER + GSTYLE_COLORBORDER
	END
	WHEN ARG(2)=5 THEN DO
		/* eingesunkener Rand */
		drawBorder=2
		call groupgadget.style GSTYLE_SUNKENBORDER, GSTYLE_SUNKENBORDER + GSTYLE_BORDER + GSTYLE_COLORBORDER
	END
	WHEN ARG(2)=6 THEN DO
		/* farbiger Rand */
		drawBorder=3
		call groupgadget.style GSTYLE_COLORBORDER, GSTYLE_SUNKENBORDER + GSTYLE_BORDER + GSTYLE_COLORBORDER
	END
    WHEN ARG(2) = 8 THEN DO
        IF mm > 1 THEN DO
            mm = mm-1
            mm_days = WORD(mon_days,mm)
            base_1st = base_1st-mm_days
            dow_1st = base_1st//7+1
            day_dif = dow_1st-1
            CALL ShowMe
        END
    END
    WHEN ARG(2) = 9 THEN CALL monthCurrent
    WHEN ARG(2) = 10 THEN DO
        IF mm < 12 THEN DO
            mm_dold = mm_days
            mm = mm+1
            mm_days = WORD(mon_days,mm)
            base_1st = base_1st+mm_dold
            dow_1st = base_1st//7+1
            day_dif = dow_1st-1
            CALL ShowMe
        END
    END
	WHEN ARG(2)=12 THEN DO
		/* Gadget schlissen. speichern der configuration. */
		call SysIni iniFile, APPKEY, GROUPPOS, groupGadget.position()
		rc = Sysini(INIFile, APPKEY, GROUPBORDER, drawBorder)
		call SysIni iniFile, APPKEY, GROUPBACKCOLOR, groupGadget.Backcolor()
        call SysIni iniFile, APPKEY, MONTHFONT, groupGadget.monthGadget.font()
        call SysIni iniFile, APPKEY, MONTHCOLOR, groupGadget.monthGadget.Color()
        call SysIni iniFile, APPKEY, MHEADFONT, groupGadget.monthHeadGadget.font()
        call SysIni iniFile, APPKEY, MHEADCOLOR, groupGadget.monthHeadGadget.Color()
        call SysIni iniFile, APPKEY, MHEADSCOLOR, groupGadget.monthShadeGadget.Color()
        call SysIni iniFile, APPKEY, DAYFONT, groupGadget.dayNumGadget.font()
        call SysIni iniFile, APPKEY, DAYCOLOR, groupGadget.dayNumGadget.Color()
        call SysIni iniFile, APPKEY, YEARFONT, groupGadget.yearNumGadget.font()
        call SysIni iniFile, APPKEY, YEARCOLOR, groupGadget.yearNumGadget.Color()
        call SysIni iniFile, APPKEY, YEARSCOLOR, groupGadget.yearShadeGadget.Color()
        rc=wizDestroyGadget("groupGadget.yearShadeGadget")
        rc=wizDestroyGadget("groupGadget.yearNumGadget")
        rc=wizDestroyGadget("groupGadget.dayNumGadget")
        rc=wizDestroyGadget("groupGadget.monthShadeGadget")
        rc=wizDestroyGadget("groupGadget.monthHeadGadget")
		rc=wizDestroyGadget("groupGadget.monthGadget")
		rc=WizDestroyGadget("groupGadget")
		exit(0)
	END
	OTHERWISE
		NOP
	END
return

onTimer:
	IF TIME('S')//60 = 0 THEN DO
    	PARSE VALUE DATE('S') WITH dy +4 dm +2 dd
	    SELECT
    		WHEN dy = yy THEN CALL ShowMe
	    	OTHERWISE CALL monthCurrent
	    END
	END

return

monthCurrent:
	PARSE VALUE DATE('S') WITH yy +4 mm +2 dd
	mm = mm/1
	dd = dd/1
	SELECT
		WHEN yy//400 = 0 THEN mon_days = '31 29 31 30 31 30 31 31 30 31 30 31'
	    WHEN yy//100 = 0 THEN mon_days = '31 28 31 30 31 30 31 31 30 31 30 31'
    	WHEN yy//4 = 0 THEN mon_days = '31 29 31 30 31 30 31 31 30 31 30 31'
	    OTHERWISE mon_days = '31 28 31 30 31 30 31 31 30 31 30 31'
	END
	mm_days = WORD(mon_days,mm)
	base_now = DATE('B')+1
	base_1st = base_now-dd
	dow_1st = base_1st//7+1
	day_dif = dow_1st-1
	CALL ShowMe

return

weekCount:
	if (date('D') - (date('B')//7)) <= 0 then 	/* erster Montag muss noch kommen */
		monday_1st = date('D') + (7 - date('B')//7)
	else										/* erster Montag ist vergangen */
		monday_1st = (date('D') - (date('B')//7))//7

	y_days = 0	/* finde nummer des Tages im Jahr */
	do mm_tmp = 1 to (mm - 1)
		y_days = y_days + word(mon_days, mm_tmp)
	end
	y_days = y_days + a

	if y_days < monday_1st then
		week_nr = 0								/* Wochen Nummer */
	else
		week_nr = (y_days - monday_1st)%7 + 1	/* Wochen Nummer */

return

ShowMe:
	/* Kalender anzeigen */
	myText=col8||'Wo. </font>'col1||'Mo  Di  Mi  Do  Fr  Sa</font>'||col2||'  So</font>'||'<br>'
	DO a = 1 TO mm_days+day_dif
    	d = a-day_dif
		if a//7 = 1 then do
			call weekCount
			myText = myText||col8||right(week_nr, 2)||'</font>'
		end
	    SELECT
	        WHEN d < 1 THEN myText = myText||COPIES(' ',4)
	        WHEN d = dd THEN myText = myText||col3||RIGHT(d,4)||'</font>'
	        WHEN a//7 = 0 THEN myText = myText||col2||RIGHT(d,4)||'</font>'
	        OTHERWISE myText = myText||RIGHT(d,4)
	    END
	    IF a//7 = 0 THEN DO
	        myText = myText||'<br>'
	    END
	END
	SELECT
	    WHEN RIGHT(myText,4) = '<br>' THEN myText = myText
	    OTHERWISE myText = myText||'<br>'
	END
	CALL groupGadget.monthGadget.text myText

	/* monat berschrift anzeigen */
	myText2='<h1>'||col4||WORD(mon_str,mm)||'</font></h1><br>'
	CALL groupGadget.monthHeadGadget.text myText2

	/* monats berschrift Schatten anzeigen */
	myText3='<h1>'||col5||WORD(mon_str,mm)||'</font></h1><br>'
	CALL groupGadget.monthShadeGadget.text myText3

	/* grosse Tages Nummer anzeigen */
	myText4 = '<h1>'||right(dd,2,'0')||'</1><br>'
	CALL groupGadget.dayNumGadget.text myText4

	/* Jahres Nummer anzeigen */
	myText5 = col6||yy||'</font><br>'
	CALL groupGadget.yearNumGadget.text myText5

	/* Jahres Nummer Schatten anzeigen */
	myText6 = col7||yy||'</font><br>'
	CALL groupGadget.yearShadeGadget.text myText6

return

quit:
exit(0)

errorHandler:
    PARSE SOURCE . . theScript

    ret=WPSWizGadgetFunc("cwDisplayRexxError", "")
    ret=WPSWizGadgetFunc("cwDisplayRexxError", theScript||": ")
    ret=WPSWizGadgetFunc("cwDisplayRexxError", "Error in line "||SIGL)

exit(0)

